package com.bipt.intelligentapplicationorchestrationservice.service.Impl;

import com.bipt.intelligentapplicationorchestrationservice.mapper.PublishMapper;
import com.bipt.intelligentapplicationorchestrationservice.pojo.ServicePublishDTO;
import com.bipt.intelligentapplicationorchestrationservice.service.PublishService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author hky
 */
@Service
@Slf4j
public class PublishServiceImpl implements PublishService {

    @Autowired
    private PublishMapper publishMapper;
    /**
     * 新增服务请求
     * @param servicePublishDTO
     */
    @Override
    @Transactional
    public void save(ServicePublishDTO servicePublishDTO) {
        String apiUrl = servicePublishDTO.getApiUrl();
        Long id = publishMapper.getByApiUrl(apiUrl);
        if (id != null){
            throw new IllegalArgumentException("请求已存在: " + apiUrl);
        }

        //todo调用服务部署

        publishMapper.insert(servicePublishDTO);
    }



}
